#region Apache 2.0 License header

//   Copyright 2012 Lesley van Zijl
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License. 

#endregion

using System;

namespace FavourObjects
{
    /// <summary>
    /// Interface used to get around dynamic casting.
    /// </summary>
    internal interface IFavourTypeBuilder
    {
        /// <summary>
        /// Main function of the Type Builder, building a Type.
        /// </summary>
        /// <returns>Type that has been build.</returns>
        Type BuildType();
    }
}