﻿#region Apache 2.0 License header

//   Copyright 2012 Lesley van Zijl
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License. 

#endregion

using System;
using System.Reflection;
using System.Text;
using FavourObjects;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Tests.Helpers;

namespace Tests
{
    [TestClass]
    public class InternalClassTests
    {
        [TestMethod]
        public void InternalClass_defaultctor_boolreturn()
        {
            var favourObject = FavourObject.Create<IPrivateClass>(typeof (PrivateTestClass));

            bool b = favourObject.Method();

            Assert.IsTrue(b);
        }

        [TestMethod]
        public void InternalClass_parameterctor_complexargs()
        {
            var favourObject = FavourObject.Create<IPrivateClass>(typeof (PrivateTestClass), 0.5);

            StringBuilder stringBuilder;
            bool b = favourObject.Method(true, 5, null, out stringBuilder,
                                         new[] {typeof (int), typeof (double), typeof (MethodInfo)});

            Assert.AreEqual("Success", stringBuilder.ToString());
            Assert.IsTrue(b);
        }

        #region Nested type: IPrivateClass

        public interface IPrivateClass
        {
            bool Method();
            bool Method(bool b, int i, MethodInfo methodInfo, out StringBuilder stringBuilder, params Type[] types);
        }

        #endregion
    }
}