﻿#region Apache 2.0 License header

//   Copyright 2012 Lesley van Zijl
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License. 

#endregion

using System.Reflection;
using FavourObjects;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Tests.Helpers;

namespace Tests
{
    [TestClass]
    public class NestedInterfacesTests
    {
        [TestMethod]
        public void NestedInterface_2deep()
        {
            var favourObject = FavourObject.Create<INestedInterface2Deep>(new TargetTestClass());

            favourObject.Method();
            MethodInfo mi = favourObject.PropertyReferenceTypeGet;

            Assert.AreEqual(5, favourObject.PropertyValueTypeGet);
        }
    }

    public interface INestedInterface2Deep : INestedInterfaceNest
    {
        void Method();
    }

    public interface INestedInterfaceNest
    {
        int PropertyValueTypeGet { get; }
        MethodInfo PropertyReferenceTypeGet { get; }
    }
}