﻿#region Apache 2.0 License header

//   Copyright 2012 Lesley van Zijl
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License. 

#endregion

using System;
using System.Linq;
using FavourObjects;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Tests.Helpers;

namespace Tests
{
    [TestClass]
    public class UnhappyFlowTests
    {
        [TestMethod]
        public void UnhappyFlow_WrongInterfaceType_ExceptionThrown()
        {
            try
            {
                FavourObject.Create<IFormatProvider>(new TargetTestClass());
                Assert.Fail();
            }
            catch (Exception)
            {
            }
        }

        [TestMethod]
        public void UnhappyFlow_MissingFunctionOnTarget_ValidationException()
        {
            try
            {
                FavourObject.Create<INonExistingFunctions>(new TargetTestClass());
                Assert.Fail();
            }
            catch (ValidationException ve)
            {
                Assert.AreEqual(1, ve.MissingMembers.Count());
            }
        }

        #region Nested type: INonExistingFunctions

        public interface INonExistingFunctions
        {
            void DoesntExist(int a, int b, double c);
        }

        #endregion
    }
}